Index: EcnlProtoTool/trunk/mruby-1.3.0/.cproject
===================================================================
--- EcnlProtoTool/trunk/mruby-1.3.0/.cproject	(revision 424)
+++ EcnlProtoTool/trunk/mruby-1.3.0/.cproject	(revision 426)
@@ -6,102 +6,81 @@
 				<externalSettings/>
 				<extensions>
-					<extension id="org.eclipse.cdt.core.PE" point="org.eclipse.cdt.core.BinaryParser"/>
 					<extension id="org.eclipse.cdt.core.ELF" point="org.eclipse.cdt.core.BinaryParser"/>
 					<extension id="org.eclipse.cdt.core.GASErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
 					<extension id="org.eclipse.cdt.core.GmakeErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
-					<extension id="org.eclipse.cdt.core.GLDErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
 					<extension id="org.eclipse.cdt.core.GCCErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
-					<extension id="com.renesas.cdt.managedbuild.renesas.core.RenesasCompilerAssemblerErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
-					<extension id="com.renesas.cdt.managedbuild.core.buildRunnerErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
-					<extension id="org.eclipse.cdt.core.MakeErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
-					<extension id="org.eclipse.cdt.core.VCErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
 					<extension id="org.eclipse.cdt.core.CWDLocator" point="org.eclipse.cdt.core.ErrorParser"/>
 				</extensions>
 			</storageModule>
 			<storageModule moduleId="cdtBuildSystem" version="4.0.0">
-				<configuration artifactName="mruby" buildProperties="org.eclipse.cdt.build.core.buildType=org.eclipse.cdt.build.core.buildType.debug" cleanCommand="rm -rf *.lst *.lis *.lpp *.map libgcc.a" description="" id="com.renesas.cdt.rz.debug.win32.configuration.Id.1552447583" name="Debug">
+				<configuration artifactName="mruby" buildProperties="org.eclipse.cdt.build.core.buildType=org.eclipse.cdt.build.core.buildType.debug" cleanCommand="rm -rf *.lst *.lis *.lpp *.map libgcc.a" description="" id="com.renesas.cdt.rz.debug.win32.configuration.Id.1552447583" name="Debug" parent="com.renesas.cdt.rz.debug.win32.configuration.Id.1552447583">
 					<folderInfo id="com.renesas.cdt.rz.debug.win32.configuration.Id.1552447583." name="/" resourcePath="">
-						<toolChain id="com.renesas.cdt.rz.debug.win32.toolchain.Id.87786683" name="KPIT GNUARM-NONE-EABI Toolchain">
-							<targetPlatform archList="all" binaryParser="org.eclipse.cdt.core.ELF;org.eclipse.cdt.core.PE" id="com.renesas.cdt.rz.debug.win32.targetplatform.Id.1600182357" name="Target Platform" osList="all"/>
-							<builder buildPath="${workspace_loc:/mruby-1.3.0}" id="com.renesas.cdt.rz.debug.win32.builder.Id.1846611762" keepEnvironmentInBuildfile="false" managedBuildOn="false" name="Builder"/>
-							<tool id="com.renesas.cdt.rz.debug.win32.tool.libgen.Id.1116635171" name="Library Generator">
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.ctype.458951408" name="ctype.h : æå­ãæ±ããã§ãã¯ãã¾ã" superClass="com.renesas.cdt.core.LibraryGenerator.option.ctype" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.math.1642753503" name="math.h : ä¸è§é¢æ°ãªã©æ°å¤ã®è¨ç®ãè¡ãã¾ã" superClass="com.renesas.cdt.core.LibraryGenerator.option.math" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.stdio.961659227" name="stdio.h : å
-¥å/åºåãè¡ãã¾ã" superClass="com.renesas.cdt.core.LibraryGenerator.option.stdio" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.stdlib.509673709" name="stdlib.h : æ ¼ç´é åã®ç®¡çãªã© C ãã­ã°ã©ã ã®æ¨æºå¦çãè¡ãã¾ã" superClass="com.renesas.cdt.core.LibraryGenerator.option.stdlib" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.string.1550848672" name="string.h : æå­åã®æ¯è¼ã¨ã³ãã¼ãè¡ãã¾ã" superClass="com.renesas.cdt.core.LibraryGenerator.option.string" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.selectLibrary.422121936" name="ã©ã¤ãã©ãªã¼ã®é¸æ" superClass="com.renesas.cdt.core.LibraryGenerator.option.selectLibrary" value="com.renesas.core.LibraryGenerator.option.selectLibrary.newLib" valueType="enumerated"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.libraryType.1589977374" name="ã©ã¤ãã©ãªã¼å" superClass="com.renesas.cdt.core.LibraryGenerator.option.libraryType" value="com.renesas.cdt.core.LibraryGenerator.option.libraryType.projectBuilt" valueType="enumerated"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.misc9.1198648676" name="åé¢æ°ããåºåãã¡ã¤ã«å
-ã®å¯¾å¿ããã»ã¯ã·ã§ã³ã«é
-ç½®ãã (-ffunction-sections)" superClass="com.renesas.cdt.core.LibraryGenerator.option.misc9" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.misc14.1587684955" name="é¢æ°ã®ã¢ãã¬ã¹ãã¬ã¸ã¹ã¿ã¼ã«ç½®ããªã (-fno-function-cse)" superClass="com.renesas.cdt.core.LibraryGenerator.option.misc14" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.misc36.1213035210" name="Parse the whole compilation unit before starting to produce code ( -funit-at-a-time)" superClass="com.renesas.cdt.core.LibraryGenerator.option.misc36" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.misc10.1626842453" name="åãã¼ã¿ããåºåãã¡ã¤ã«å
-ã®å¯¾å¿ããã»ã¯ã·ã§ã³ã«é
-ç½®ãã (-fdata-sections)" superClass="com.renesas.cdt.core.LibraryGenerator.option.misc10" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.core.LibraryGenerator.option.misc37.476113883" name="Align branch targets to a power-of-two boundary (-falign-jumps)" superClass="com.renesas.cdt.core.LibraryGenerator.option.misc37" value="true" valueType="boolean"/>
+						<toolChain id="com.renesas.cdt.managedbuild.gcc.rz.toolchain.base.1293524778" name="GCC for Renesas RZ" superClass="com.renesas.cdt.managedbuild.gcc.rz.toolchain.base">
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.deviceName.1132450937" name="Device name" superClass="com.renesas.cdt.managedbuild.gcc.rz.deviceName"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.createlibgen.122319692" name="Create libgen" superClass="com.renesas.cdt.managedbuild.gcc.rz.createlibgen" value="false" valueType="boolean"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.warnStack.584176958" name="Warn if stack size exceeds the limit, in bytes (-Wstack-usage)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.warnStack"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.stackSizeInDecimal.2117033791" name="Decimal representation of '-Wstack-usage'" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.stackSizeInDecimal"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.otherDebug.1643801869" name="Other debugging flags" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.otherDebug"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.otherOptimization.1481647151" name="Other optimization flags" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.otherOptimization"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.otherTarget.546455467" name="Other target flags" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.otherTarget"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.otherWarnings.1615987444" name="Other warning flags" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.otherWarnings"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.warnings.nulldereference.1424199987" name="Null pointer dereference [-Wnull-dereference]" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.warnings.nulldereference"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.optimizationLevel.207902203" name="Optimization Level" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.optimizationLevel"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.signedchar.957528705" name="'char' is signed (-fsigned-char)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.signedchar"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.functionsection.624322011" name="Function sections (-ffunction-sections)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.functionsection"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.datasections.869721791" name="Data sections (-fdata-sections)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.datasections"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.messagelenght.564993884" name="Message length (-fmessage-length=0)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.messagelenght"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.noinlinefunctions.930902268" name="Do not inline functions (-fno-inline-functions)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.noinlinefunctions"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.freestanding.1835552049" name="Assume freestanding environment (-ffreestanding)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.freestanding"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.nobuiltin.1844976266" name="Disable builtin (-fno-builtin)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.nobuiltin"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.nocommon.257711696" name="No common unitialized (-fno-common)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.nocommon"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.pic.1145554879" name="Position independent code (-fPIC)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.pic"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.family.545769181" name="ARM family" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.family"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.architecture.341336431" name="Architecture" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.architecture"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.instructionset.1361255787" name="Instruction set" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.instructionset"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.spconstant.891621000" name="Single precision constants (-fsingle-precision-constant)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.spconstant"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.endian.1800094875" name="Endianness" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.endian"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.floatabi.1857840177" name="Float ABI" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.floatabi"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.floatunit.115322157" name="FPU Type" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.floatunit"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.unaligned.990219082" name="Unaligned access" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.unaligned"/>
+							<option id="com.renesas.cdt.managedbuild.gcc.rz.option.thumb.629023669" name="Thumb interwork (-mthumb-interwork)" superClass="com.renesas.cdt.managedbuild.gcc.rz.option.thumb"/>
+							<option id="ilg.gnuarmeclipse.managedbuild.cross.option.debugging.level.1472716966" name="Debug level" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.debugging.level"/>
+							<option id="ilg.gnuarmeclipse.managedbuild.cross.option.debugging.format.319338384" name="Debug format" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.debugging.format"/>
+							<option id="ilg.gnuarmeclipse.managedbuild.cross.option.addtools.createflash.1907336908" name="Create flash image" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.addtools.createflash" value="true" valueType="boolean"/>
+							<targetPlatform archList="all" binaryParser="org.eclipse.cdt.core.ELF" id="ilg.gnuarmeclipse.managedbuild.cross.targetPlatform.194370869" isAbstract="false" osList="all" superClass="ilg.gnuarmeclipse.managedbuild.cross.targetPlatform"/>
+							<builder buildPath="${workspace_loc:/mruby-1.3.0}" id="com.renesas.cdt.managedbuild.gcc.rz.builder.1751464165" keepEnvironmentInBuildfile="false" managedBuildOn="false" name="GCC for Renesas Builder" superClass="com.renesas.cdt.managedbuild.gcc.rz.builder"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.assembler.322468629" name="Cross ARM GNU Assembler" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.assembler">
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.assembler.usepreprocessor.1448772766" name="Use preprocessor" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.assembler.usepreprocessor" value="true" valueType="boolean"/>
+								<inputType id="ilg.gnuarmeclipse.managedbuild.cross.tool.assembler.input.811183051" superClass="ilg.gnuarmeclipse.managedbuild.cross.tool.assembler.input"/>
 							</tool>
-							<tool id="com.renesas.cdt.rz.debug.win32.tool.compiler.Id.2114772705" name="Compiler">
-								<option defaultValue="true" id="com.renesas.cdt.core.Compiler.option.misc2.2071139574" name="æ¨æºã·ã¹ãã ã»ãã£ã¬ã¯ããªã¼ã§ãããã¼ã»ãã¡ã¤ã«ãæ¤ç´¢ããªã (-nostdinc)" superClass="com.renesas.cdt.core.Compiler.option.misc2" value="false" valueType="boolean"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.architecture.712090671" name="ã¢ã¼ã­ãã¯ãã£ã¼" superClass="com.renesas.cdt.rz.Debug.Compiler.option.architecture" value="com.renesas.cdt.rz.Debug.Compiler.option.architecture.armv7a" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.cpuType.1792387458" name="CPU ã¿ã¤ã" superClass="com.renesas.cdt.rz.Debug.Compiler.option.cpuType" value="com.renesas.cdt.rz.Debug.Compiler.option.cpuType.rza" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.dataEndian.1830244232" name="ã¨ã³ãã£ã¢ã³" superClass="com.renesas.cdt.rz.Debug.Compiler.option.dataEndian" value="com.renesas.cdt.rz.Debug.Compiler.option.dataEndian.little" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.instructionset.1447259851" name="å½ä»¤ã»ãã" superClass="com.renesas.cdt.rz.Debug.Compiler.option.instructionset" value="com.renesas.cdt.rz.Debug.Compiler.option.instructionset.arm" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.interworking.260043818" name="ã¤ã³ã¿ã¼ã»ã¯ã¼ã­ã³ã° (-mthumb-interwork)" superClass="com.renesas.cdt.rz.Debug.Compiler.option.interworking" value="true" valueType="boolean"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.targetfpu.367057389" name="ã¿ã¼ã²ãã FPU (-mfpu)" superClass="com.renesas.cdt.rz.Debug.Compiler.option.targetfpu" value="com.renesas.cdt.rz.Debug.Compiler.option.targetfpu.vfp" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Compiler.option.floatingpointabi.1426976645" name="æµ®åå°æ°ç¹ ABI (-mfloat-abi=name)" superClass="com.renesas.cdt.rz.Debug.Compiler.option.floatingpointabi" value="com.renesas.cdt.rz.Debug.Compiler.option.floatingpointabi.soft" valueType="enumerated"/>
-								<option id="com.renesas.cdt.core.Compiler.option.warnStackSize.1147490000" name="Warn if stack size exceeds the limit (-Wstack-usage) (H')" superClass="com.renesas.cdt.core.Compiler.option.warnStackSize" value="100" valueType="string"/>
-								<option id="com.renesas.cdt.core.Compiler.option.CPUSeries.1824596418" name="CPU ã·ãªã¼ãº" superClass="com.renesas.cdt.core.Compiler.option.CPUSeries" value="RZ/A" valueType="string"/>
-								<option id="com.renesas.cdt.core.Compiler.option.device.961121392" name="Device" superClass="com.renesas.cdt.core.Compiler.option.device" value="R7S721001" valueType="string"/>
-								<option id="com.renesas.cdt.core.Compiler.option.deviceShortName.635132041" name="DeviceShortName" superClass="com.renesas.cdt.core.Compiler.option.deviceShortName" value="R7S721001" valueType="string"/>
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.rz.Debug.Compiler.option.macroDefines.57380421" name="ãã¯ã­å®ç¾©" superClass="com.renesas.cdt.rz.Debug.Compiler.option.macroDefines" valueType="definedSymbols">
-									<listOptionValue builtIn="false" value="SIMULATOR_DEBUG"/>
-									<listOptionValue builtIn="false" value="CPPAPP"/>
-								</option>
-								<inputType id="%Base.Compiler.C.InputType.Id.379655366" name="C å
-¥å"/>
-								<inputType id="Base.Compiler.CPP.InputType.Id.1101890027" name="C++ å
-¥å"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.compiler.c.1483126921" name="Cross ARM C Compiler" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.compiler.c"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.compiler.cpp.935511993" name="Cross ARM C++ Compiler" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.compiler.cpp">
+								<inputType id="ilg.gnuarmeclipse.managedbuild.cross.tool.cpp.compiler.input.1782715602" superClass="ilg.gnuarmeclipse.managedbuild.cross.tool.cpp.compiler.input"/>
+								<inputType id="com.renesas.cdt.managedbuild.gcc.rz.inputType.compiler.c.1073709068" superClass="com.renesas.cdt.managedbuild.gcc.rz.inputType.compiler.c"/>
 							</tool>
-							<tool id="com.renesas.cdt.rz.debug.win32.tool.assembler.Id.1166037999" name="Assembler">
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.architecture.1178720663" name="ã¢ã¼ã­ãã¯ãã£ã¼" superClass="com.renesas.cdt.rz.Debug.Assembler.option.architecture" value="com.renesas.cdt.rz.Debug.Assembler.option.architecture.armv7a" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.cpuType.1700798679" name="CPU ã¿ã¤ã" superClass="com.renesas.cdt.rz.Debug.Assembler.option.cpuType" value="com.renesas.cdt.rz.Debug.Assembler.option.cpuType.rza" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.dataEndian.835685972" name="ã¨ã³ãã£ã¢ã³" superClass="com.renesas.cdt.rz.Debug.Assembler.option.dataEndian" value="com.renesas.cdt.rz.Debug.Assembler.option.dataEndian.little" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.instructionset.1591801771" name="å½ä»¤ã»ãã" superClass="com.renesas.cdt.rz.Debug.Assembler.option.instructionset" value="com.renesas.cdt.rz.Debug.Assembler.option.instructionset.arm" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.targetfpu.1672411105" name="ã¿ã¼ã²ãã FPU (-mfpu)" superClass="com.renesas.cdt.rz.Debug.Assembler.option.targetfpu" value="com.renesas.cdt.rz.Debug.Assembler.option.targetfpu.vfp" valueType="enumerated"/>
-								<option id="com.renesas.cdt.rz.Debug.Assembler.option.floatingpointabi.1400638226" name="æµ®åå°æ°ç¹ ABI (-mfloat-abi=name)" superClass="com.renesas.cdt.rz.Debug.Assembler.option.floatingpointabi" value="com.renesas.cdt.rz.Debug.Assembler.option.floatingpointabi.soft" valueType="enumerated"/>
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.core.Assembler.option.includeFileDirectories.1632699435" name="ã¤ã³ã¯ã«ã¼ãã»ãã¡ã¤ã«ã»ãã£ã¬ã¯ããªã¼" superClass="com.renesas.cdt.core.Assembler.option.includeFileDirectories" valueType="includePath">
-									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/${ProjName}}/src&quot;"/>
-								</option>
-								<inputType id="%Base.Assembler.inputType.Id.1006307562" name="ã¢ã»ã³ãã©ã¼å
-¥åã¿ã¤ã"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.linker.c.1891149191" name="Cross ARM C Linker" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.linker.c">
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.c.linker.gcsections.194050233" name="Remove unused sections (-Xlinker --gc-sections)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.c.linker.gcsections" value="true" valueType="boolean"/>
 							</tool>
-							<tool id="com.renesas.cdt.rz.debug.win32.tool.linker.Id.497903742" name="Linker">
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.rz.Debug.Linker.option.archiveSearchDirectories.2062570669" name="ã¢ã¼ã«ã¤ãæ¤ç´¢ãã£ã¬ã¯ããªã¼" superClass="com.renesas.cdt.rz.Debug.Linker.option.archiveSearchDirectories" valueType="stringList">
-									<listOptionValue builtIn="false" value="&quot;${CONFIGDIR}&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;${TCINSTALL}/lib/gcc/arm-none-eabi/${GCC_VERSION}&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;${TCINSTALL}/arm-none-eabi/lib&quot;"/>
-								</option>
-								<option id="com.renesas.cdt.rz.Debug.Linker.option.dataEndian.718941051" name="ã¨ã³ãã£ã¢ã³" superClass="com.renesas.cdt.rz.Debug.Linker.option.dataEndian" value="com.renesas.cdt.rz.Debug.Linker.option.dataEndian.little" valueType="enumerated"/>
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.rz.Debug.Linker.option.archiveLibraryFiles.6194456" name="ã¢ã¼ã«ã¤ã ( ã©ã¤ãã©ãªã¼ ) ãã¡ã¤ã«" superClass="com.renesas.cdt.rz.Debug.Linker.option.archiveLibraryFiles" valueType="stringList">
-									<listOptionValue builtIn="false" value="${BuildArtifactFileBaseName}"/>
-									<listOptionValue builtIn="false" value="gcc"/>
-									<listOptionValue builtIn="false" value="stdc++"/>
-								</option>
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.core.Linker.option.userDefinedOptions.947383497" name="ã¦ã¼ã¶ã¼å®ç¾©ãªãã·ã§ã³" superClass="com.renesas.cdt.core.Linker.option.userDefinedOptions" valueType="stringList">
-									<listOptionValue builtIn="false" value="-e_PowerON_Reset"/>
-								</option>
-								<option IS_BUILTIN_EMPTY="false" IS_VALUE_EMPTY="false" id="com.renesas.cdt.core.Linker.option.linkOrderList.298210254" name="" superClass="com.renesas.cdt.core.Linker.option.linkOrderList" valueType="stringList">
-									<listOptionValue builtIn="false" value="&quot;.\src\hardware_setup.o&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;.\src\interrupt_handlers.o&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;.\src\mruby.o&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;.\src\reset_program.o&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;.\src\vector_table.o&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;.\libmruby.a&quot;"/>
-								</option>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.linker.cpp.1081730003" name="Cross ARM C++ Linker" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.linker.cpp">
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.cpp.linker.gcsections.287809380" name="Remove unused sections (-Xlinker --gc-sections)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.cpp.linker.gcsections" value="true" valueType="boolean"/>
+								<inputType id="com.renesas.cdt.managedbuild.gcc.rz.inputType.linker.cpp.560978425" superClass="com.renesas.cdt.managedbuild.gcc.rz.inputType.linker.cpp">
+									<additionalInput kind="additionalinputdependency" paths="$(USER_OBJS)"/>
+									<additionalInput kind="additionalinputdependency" paths="$(LIBRARY_GENERATOR_OUTPUTTYPE_OUTPUTS)"/>
+									<additionalInput kind="additionaldependency" paths="$(LINKER_SCRIPT)"/>
+								</inputType>
 							</tool>
-							<tool id="com.renesas.cdt.rz.debug.win32.tool.objcopy.Id.1923834783" name="Objcopy"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.archiver.470065479" name="Cross ARM GNU Archiver" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.archiver"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.flash.140052306" name="Cross ARM GNU Create Flash Image" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.flash"/>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.listing.704900212" name="Cross ARM GNU Create Listing" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.listing">
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.source.1868297379" name="Display source (--source|-S)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.source" value="true" valueType="boolean"/>
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.allheaders.2058974757" name="Display all headers (--all-headers|-x)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.allheaders" value="true" valueType="boolean"/>
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.demangle.640151966" name="Demangle names (--demangle|-C)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.demangle" value="true" valueType="boolean"/>
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.linenumbers.68234501" name="Display line numbers (--line-numbers|-l)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.linenumbers" value="true" valueType="boolean"/>
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.wide.1986410872" name="Wide lines (--wide|-w)" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.createlisting.wide" value="true" valueType="boolean"/>
+							</tool>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.size.1320038869" name="Cross ARM GNU Print Size" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.size">
+								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.printsize.format.231473645" name="Size format" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.printsize.format"/>
+							</tool>
+							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.libgen.1477349549" name="Library Generator" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.libgen"/>
 						</toolChain>
 					</folderInfo>
@@ -112,5 +91,8 @@
 			</storageModule>
 			<storageModule moduleId="org.eclipse.cdt.core.externalSettings"/>
-			<storageModule moduleId="com.renesas.cdt.managedbuild.core.toolchainInfo"/>
+			<storageModule moduleId="com.renesas.cdt.managedbuild.core.toolchainInfo">
+				<option id="toolchain.id" value="gcc-arm-embedded"/>
+				<option id="toolchain.version" value="6.3.1.20170620"/>
+			</storageModule>
 		</cconfiguration>
 	</storageModule>